'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = function (_React$Component) {
    _inherits(Button, _React$Component);

    function Button() {
        _classCallCheck(this, Button);

        return _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).apply(this, arguments));
    }

    _createClass(Button, [{
        key: 'onClick',
        value: function onClick(e) {
            this.props.onClick && this.props.onClick(e);
        }
    }, {
        key: 'render',
        value: function render() {
            var _classNames;

            var _props = this.props,
                disabled = _props.disabled,
                icon = _props.icon,
                type = _props.type,
                size = _props.size,
                className = _props.className,
                style = _props.style,
                children = _props.children,
                onMouseEnter = _props.onMouseEnter,
                onMouseLeave = _props.onMouseLeave;

            var classname = (0, _classnames2.default)((_classNames = {
                'visui-btn': true
            }, _defineProperty(_classNames, 'visui-btn-' + type, type), _defineProperty(_classNames, 'visui-btn-small', size === 'small'), _defineProperty(_classNames, 'visui-btn-large', size === 'large'), _defineProperty(_classNames, className, className), _classNames));
            return _react2.default.createElement(
                'button',
                {
                    disabled: disabled,
                    className: classname,
                    style: style,
                    onMouseEnter: onMouseEnter,
                    onMouseLeave: onMouseLeave,
                    onClick: this.onClick.bind(this)
                },
                icon && _react2.default.createElement(_icon2.default, { type: icon }),
                _react2.default.createElement(
                    'span',
                    null,
                    children
                )
            );
        }
    }]);

    return Button;
}(_react2.default.Component);

Button.defaultProps = {
    type: 'default',
    disabled: false
};

Button.propTypes = {
    onClick: _propTypes2.default.func,
    onMouseEnter: _propTypes2.default.func,
    onMouseLeave: _propTypes2.default.func,
    type: _propTypes2.default.string,
    size: _propTypes2.default.string,
    icon: _propTypes2.default.string,
    disabled: _propTypes2.default.bool
};

exports.default = Button;