'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

var _enzyme = require('enzyme');

var _sinon = require('sinon');

var _sinon2 = _interopRequireDefault(_sinon);

var _enzymeAdapterReact = require('enzyme-adapter-react-16');

var _enzymeAdapterReact2 = _interopRequireDefault(_enzymeAdapterReact);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _enzyme.configure)({ adapter: new _enzymeAdapterReact2.default() }); /**
                                                                          * @file test CheckboxList
                                                                          */


var CheckboxRadioList = _index2.default.Radio;

describe('enzyme test CheckboxList before click', function () {
    var onChange = _sinon2.default.spy();
    var wrapper = (0, _enzyme.shallow)(_react2.default.createElement(_index2.default, {
        title: '\u97F3\u4E50\u7C7B\u578B',
        options: [{ label: 'R&B', value: 1 }, { label: 'Jazz', value: 2 }, { label: 'Soul', value: 3 }],
        onChange: onChange
    }));

    it('checklist panel should be closed', function () {
        expect(wrapper.hasClass('visui-checkboxlist-down-container')).toBeFalsy();
    });

    it('title should be 音乐类型', function () {
        expect(wrapper.find('.visui-checkboxlist-title-text').text()).toEqual('音乐类型');
    });
});

describe('enzyme test CheckboxList after click', function () {
    var onChange = _sinon2.default.spy();
    var wrapper = (0, _enzyme.mount)(_react2.default.createElement(_index2.default, {
        title: '\u97F3\u4E50\u7C7B\u578B',
        options: [{ label: 'R&B', value: 1 }, { label: 'Jazz', value: 2 }, { label: 'Soul', value: 3 }],
        onChange: onChange
    }));

    wrapper.find('.visui-checkboxlist-title-container').simulate('click');

    it('checklist panel should be open after body clicked', function () {
        expect(wrapper.find('.visui-checkboxlist-down-container').exists()).toBeTruthy();
    });

    it('checklist panel options should be number of 3', function () {
        expect(wrapper.find('visui-checkbox-group-item').length).toEqual(3);
    });

    it('when options changed, onChange() should be called', function () {
        wrapper.find('.visui-checkbox-wrapper').first().simulate('click');
        expect(onChange).toHaveProperty('callCount', 1);
    });
});

describe('enzyme test CheckboxRadioList before click', function () {
    var onChange = _sinon2.default.spy();
    var wrapper = (0, _enzyme.shallow)(_react2.default.createElement(CheckboxRadioList, {
        title: '\u821E\u8E48\u7C7B\u578B',
        options: [{ label: 'Popping', value: 4 }, { label: 'Locking', value: 5 }, { label: 'Breaking', value: 6 }],
        onChange: onChange
    }));

    it('checklist panel should be closed', function () {
        expect(wrapper.hasClass('visui-checkboxlist-down-container')).toBeFalsy();
    });

    it('title should be 音乐类型', function () {
        expect(wrapper.find('.visui-checkboxlist-title-text').text()).toEqual('舞蹈类型');
    });
});

describe('enzyme test CheckboxRadioList after click', function () {
    var onChange = _sinon2.default.spy();
    var wrapper = (0, _enzyme.shallow)(_react2.default.createElement(CheckboxRadioList, {
        title: '\u821E\u8E48\u7C7B\u578B',
        options: [{ label: 'Popping', value: 4 }, { label: 'Locking', value: 5 }, { label: 'Breaking', value: 6 }],
        onChange: onChange
    }));

    wrapper.find('.visui-checkboxlist-title-container').simulate('click');

    it('checklist panel should be open after body clicked', function () {
        expect(wrapper.find('.visui-checkboxlist-down-container').exists()).toBeTruthy();
    });

    it('checklist panel options should be number of 3', function () {
        expect(wrapper.find('visui-radio-group-item').length).toEqual(3);
    });

    it('when options changed, onChange() should be called', function () {
        wrapper.find('.visui-radio-wrapper').first().simulate('click');
        expect(onChange).toHaveProperty('callCount', 1);
    });
});