'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _index = require('../../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file CheckboxList 单选下拉组件（下拉为checkbox多选框）
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author hedongran
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var CheckboxGroup = _index.Checkbox.Group;

var CheckboxList = function (_React$Component) {
    _inherits(CheckboxList, _React$Component);

    function CheckboxList(props) {
        _classCallCheck(this, CheckboxList);

        var _this = _possibleConstructorReturn(this, (CheckboxList.__proto__ || Object.getPrototypeOf(CheckboxList)).call(this, props));

        _this.state = {
            showDown: false,
            indeterminate: _this.getDefaultIndeterminate(props),
            checkAll: _this.getDefaultCheckAll(props),
            checkTitle: _this.getDefaultCheckTitle(props),
            checkedList: props.value || props.defaultValue || []
        };
        _this.bodyClick = _this.bodyClick.bind(_this);
        _this.onChange = _this.onChange.bind(_this);
        _this.onCheckAllChange = _this.onCheckAllChange.bind(_this);
        _this.onCheckedListChange = _this.onCheckedListChange.bind(_this);
        _this.onCheckedTitle = _this.onCheckedTitle.bind(_this);
        return _this;
    }

    _createClass(CheckboxList, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            // 外部通过value属性使组件受控
            if ('value' in nextProps && !(0, _shallowequal2.default)(nextProps.value, this.props.value)) {
                var checkedList = nextProps.value;
                this.setState({
                    checkedList: checkedList,
                    indeterminate: !!checkedList.length && checkedList.length < this.props.options.length,
                    checkAll: checkedList.length === this.props.options.length,
                    checkTitle: !!checkedList.length
                });
            }
        }

        /**
         * 获取初始状态标题外checkbox选中状态
         *
         * @param {Object} props react的props属性
         * @return {boolean} 选中状态
         */

    }, {
        key: 'getDefaultCheckTitle',
        value: function getDefaultCheckTitle(props) {
            if ('value' in props) {
                return Boolean(props.value.length);
            }
            return Boolean(props.defaultValue.length);
        }

        /**
         * 获取初始状态面板内全选Checkbox选中状态
         *
         * @param {Object} props react的props属性
         * @return {boolean} 选中状态
         */

    }, {
        key: 'getDefaultCheckAll',
        value: function getDefaultCheckAll(props) {
            if ('value' in props) {
                return props.value.length === props.options.length;
            }
            return props.defaultValue.length === props.options.length;
        }

        /**
         * 获取初始状态面板内Indeterminate Checkbox选中状态
         *
         * @param {Object} props react的props属性
         * @return {boolean} 选中状态
         */

    }, {
        key: 'getDefaultIndeterminate',
        value: function getDefaultIndeterminate(props) {
            if ('value' in props) {
                return !!props.value.length && props.value.length < props.options.length;
            }
            return !!props.defaultValue.length && props.defaultValue.length < props.options.length;
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            window.addEventListener('click', this.bodyClick);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            window.removeEventListener('click', this.bodyClick);
        }

        /**
         * 监听用户点击事件，当点击不在面板内时收起面板
         *
         * @param {Object} e 用户点击事件
         */

    }, {
        key: 'bodyClick',
        value: function bodyClick(e) {
            var dom = e.target;
            var flag = true;
            var showDown = this.state.showDown;
            while (dom) {
                if (dom === this.refs.titleContainer) {
                    flag = false;
                    break;
                }
                dom = dom.parentNode;
            }
            if (flag && showDown) {
                this.setState({
                    showDown: false
                });
            }
        }

        /**
         * 面板内Checkbox的点击回调事件
         *
         * @param {Array} checkedList 面板内Checkbox的选中值
         */

    }, {
        key: 'onChange',
        value: function onChange(checkedList) {
            this.setState({
                checkedList: checkedList,
                indeterminate: !!checkedList.length && checkedList.length < this.props.options.length,
                checkAll: checkedList.length === this.props.options.length,
                checkTitle: !!checkedList.length
            }, this.onCheckedListChange);
        }

        /**
         * 面板内全选Checkbox的点击回调事件
         *
         * @param {boolen} checked 面板内全选Checkbox的选中状态
         */

    }, {
        key: 'onCheckAllChange',
        value: function onCheckAllChange(checked) {
            this.setState({
                checkedList: checked ? this.props.options.map(function (item) {
                    return item.value;
                }) : [],
                indeterminate: false,
                checkAll: checked,
                checkTitle: checked
            }, this.onCheckedListChange);
        }

        /**
         * 组件给父组件的回调事件
         */

    }, {
        key: 'onCheckedListChange',
        value: function onCheckedListChange() {
            this.props.onChange && this.props.onChange(this.state.checkedList);
        }

        /**
         * 面板外Checkbox的点击回调事件
         *
         * @param {boolen} checked 面板外Checkbox的选中状态
         */

    }, {
        key: 'onCheckedTitle',
        value: function onCheckedTitle(checked) {
            var _props = this.props,
                options = _props.options,
                defaultCheckedKey = _props.defaultCheckedKey;

            if (checked && this.state.checkedList.length === 0) {
                var checkedList = options[defaultCheckedKey] && [options[defaultCheckedKey].value];
                this.setState({
                    checkTitle: checked,
                    indeterminate: true,
                    checkedList: checkedList || []
                }, this.onCheckedListChange);
            } else if (!checked) {
                this.setState({
                    checkTitle: checked,
                    indeterminate: false,
                    checkAll: false,
                    checkedList: []
                }, this.onCheckedListChange);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _state = this.state,
                checkTitle = _state.checkTitle,
                checkAll = _state.checkAll,
                indeterminate = _state.indeterminate,
                checkedList = _state.checkedList,
                showDown = _state.showDown;
            var _props2 = this.props,
                className = _props2.className,
                style = _props2.style,
                title = _props2.title,
                options = _props2.options,
                disabled = _props2.disabled;

            var classname = (0, _classnames2.default)(_defineProperty({
                'visui-checkboxlist': true
            }, className, className));
            return _react2.default.createElement(
                'div',
                { className: classname, style: style },
                _react2.default.createElement(
                    'div',
                    { ref: 'titleContainer',
                        className: 'visui-checkboxlist-title-container',
                        onClick: function onClick(e) {
                            _this2.setState({
                                showDown: !showDown
                            });
                        }
                    },
                    _react2.default.createElement(_index.Checkbox, { checked: checkTitle, onChange: this.onCheckedTitle, disabled: disabled }),
                    _react2.default.createElement(
                        'span',
                        { className: 'visui-checkboxlist-title-text' },
                        title,
                        checkedList.length > 0 && _react2.default.createElement(
                            'span',
                            { className: 'visui-checkboxlist-num' },
                            '(',
                            checkedList.length,
                            ')'
                        )
                    ),
                    _react2.default.createElement(_index.Icon, { type: 'arrow-down' })
                ),
                showDown && _react2.default.createElement(
                    'div',
                    { className: 'visui-checkboxlist-down-container', onClick: function onClick(e) {
                            e.nativeEvent.stopImmediatePropagation();
                        } },
                    _react2.default.createElement(
                        'div',
                        { key: -1, className: 'visui-checkboxlist-down-line' },
                        _react2.default.createElement(
                            _index.Checkbox,
                            { onChange: this.onCheckAllChange,
                                indeterminate: indeterminate,
                                checked: checkAll,
                                disabled: disabled },
                            '\u5168\u9009'
                        )
                    ),
                    _react2.default.createElement(
                        CheckboxGroup,
                        { onChange: this.onChange, value: checkedList, disabled: disabled },
                        options && options.map(function (checkbox, index) {
                            return _react2.default.createElement(
                                _index.Checkbox,
                                { value: checkbox.value, key: index },
                                checkbox.label
                            );
                        })
                    )
                )
            );
        }
    }]);

    return CheckboxList;
}(_react2.default.Component);

CheckboxList.defaultProps = {
    title: '',
    options: [],
    defaultCheckedKey: 0,
    defaultValue: []
};

CheckboxList.propTypes = {
    title: _propTypes2.default.string.isRequired,
    defaultCheckedKey: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    defaultValue: _propTypes2.default.array,
    options: _propTypes2.default.array,
    onChange: _propTypes2.default.func
};

exports.default = CheckboxList;