'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _index = require('../../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file CheckboxList 单选下拉组件（下拉为radio单选框）
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author hedongran
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var RadioGroup = _index.Radio.Group;

var CheckboxRadioList = function (_React$Component) {
    _inherits(CheckboxRadioList, _React$Component);

    function CheckboxRadioList(props) {
        _classCallCheck(this, CheckboxRadioList);

        var _this = _possibleConstructorReturn(this, (CheckboxRadioList.__proto__ || Object.getPrototypeOf(CheckboxRadioList)).call(this, props));

        _this.state = {
            showDown: false,
            checkTitle: _this.getDefaultCheckTitle(props),
            checkedVal: _this.getDefaultCheckVal(props)
        };
        _this.bodyClick = _this.bodyClick.bind(_this);
        _this.onChange = _this.onChange.bind(_this);
        _this.onCheckedValChange = _this.onCheckedValChange.bind(_this);
        _this.onCheckedTitle = _this.onCheckedTitle.bind(_this);
        return _this;
    }

    _createClass(CheckboxRadioList, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            // 外部通过value属性使组件受控
            if ('value' in nextProps && nextProps.value !== this.props.value) {
                var checkedVal = nextProps.value;
                this.setState({
                    checkedVal: checkedVal,
                    checkTitle: !!checkedVal
                });
            }
        }

        /**
         * 获取初始状态标题外checkbox选中状态
         *
         * @param {Object} props react的props属性
         * @return {boolean} 选中状态
         */

    }, {
        key: 'getDefaultCheckTitle',
        value: function getDefaultCheckTitle(props) {
            if ('value' in props) {
                return Boolean(props.value);
            }
            return Boolean(props.defaultValue);
        }

        /**
         * 获取初始状态面板内RadioGroup的值
         *
         * @param {Object} props react的props属性
         * @return {string | number} 面板内RadioGroup的值
         */

    }, {
        key: 'getDefaultCheckVal',
        value: function getDefaultCheckVal(props) {
            if ('value' in props) {
                return props.value;
            } else if ('defaultValue' in props) {
                return props.defaultValue;
            } else {
                return undefined;
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            window.addEventListener('click', this.bodyClick);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            window.removeEventListener('click', this.bodyClick);
        }

        /**
         * 监听用户点击事件，当点击不在面板内时收起面板
         *
         * @param {Object} e 用户点击事件
         */

    }, {
        key: 'bodyClick',
        value: function bodyClick(e) {
            var dom = e.target;
            var flag = true;
            var showDown = this.state.showDown;
            while (dom) {
                if (dom === this.refs.titleContainer) {
                    flag = false;
                    break;
                }
                dom = dom.parentNode;
            }
            if (flag && showDown) {
                this.setState({
                    showDown: false
                });
            }
        }

        /**
         * 面板内RadioGroup的点击回调事件
         *
         * @param {string | number} checkedVal 面板内RadioGroup的选中值
         */

    }, {
        key: 'onChange',
        value: function onChange(checkedVal) {
            this.setState({
                checkedVal: checkedVal,
                checkTitle: !!checkedVal
            }, this.onCheckedValChange);
        }

        /**
         * 组件给父组件的回调事件
         */

    }, {
        key: 'onCheckedValChange',
        value: function onCheckedValChange() {
            this.props.onChange && this.props.onChange(this.state.checkedVal);
        }

        /**
         * 面板外Checkbox的点击回调事件
         *
         * @param {boolen} checked 面板外Checkbox的选中状态
         */

    }, {
        key: 'onCheckedTitle',
        value: function onCheckedTitle(checked) {
            var _props = this.props,
                options = _props.options,
                defaultCheckedKey = _props.defaultCheckedKey;

            if (checked && this.state.checkedVal === undefined) {
                var checkedVal = options[defaultCheckedKey] && options[defaultCheckedKey].value;
                this.setState({
                    checkTitle: checked,
                    checkedVal: checkedVal || undefined
                }, this.onCheckedValChange);
            } else if (!checked) {
                this.setState({
                    checkTitle: checked,
                    checkedVal: undefined
                }, this.onCheckedValChange);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _state = this.state,
                checkTitle = _state.checkTitle,
                checkedVal = _state.checkedVal,
                showDown = _state.showDown;
            var _props2 = this.props,
                className = _props2.className,
                style = _props2.style,
                title = _props2.title,
                options = _props2.options,
                disabled = _props2.disabled;

            var classname = (0, _classnames2.default)(_defineProperty({
                'visui-checkboxlist': true
            }, className, className));
            return _react2.default.createElement(
                'div',
                { className: classname, style: style },
                _react2.default.createElement(
                    'div',
                    { ref: 'titleContainer',
                        className: 'visui-checkboxlist-title-container',
                        onClick: function onClick(e) {
                            _this2.setState({
                                showDown: !showDown
                            });
                        }
                    },
                    _react2.default.createElement(_index.Checkbox, { checked: checkTitle, onChange: this.onCheckedTitle, disabled: disabled }),
                    _react2.default.createElement(
                        'span',
                        { className: 'visui-checkboxlist-title-text' },
                        title
                    ),
                    _react2.default.createElement(_index.Icon, { type: 'arrow-down' })
                ),
                showDown && _react2.default.createElement(
                    'div',
                    { className: 'visui-checkboxlist-down-container', onClick: function onClick(e) {
                            e.nativeEvent.stopImmediatePropagation();
                        } },
                    _react2.default.createElement(
                        RadioGroup,
                        { onChange: this.onChange, value: checkedVal, disabled: disabled },
                        options && options.map(function (checkbox, index) {
                            return _react2.default.createElement(
                                _index.Radio,
                                { value: checkbox.value, key: index },
                                checkbox.label
                            );
                        })
                    )
                )
            );
        }
    }]);

    return CheckboxRadioList;
}(_react2.default.Component);

CheckboxRadioList.defaultProps = {
    title: '',
    options: [],
    defaultCheckedKey: 0,
    defaultValue: undefined
};

CheckboxRadioList.propTypes = {
    title: _propTypes2.default.string.isRequired,
    defaultCheckedKey: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    defaultValue: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.string, _propTypes2.default.number]),
    options: _propTypes2.default.array,
    onChange: _propTypes2.default.func
};

exports.default = CheckboxRadioList;