'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CheckboxGroup = function (_React$Component) {
    _inherits(CheckboxGroup, _React$Component);

    function CheckboxGroup(props) {
        _classCallCheck(this, CheckboxGroup);

        var _this = _possibleConstructorReturn(this, (CheckboxGroup.__proto__ || Object.getPrototypeOf(CheckboxGroup)).call(this, props));

        _this.state = {
            options: props.value || props.defaultValue
        };
        return _this;
    }

    _createClass(CheckboxGroup, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.value !== this.props.value) {
                this.setState({
                    options: nextProps.value || nextProps.defaultValue
                });
            }
        }
    }, {
        key: 'getChildContext',
        value: function getChildContext() {
            return {
                component: this
            };
        }
    }, {
        key: 'onChange',
        value: function onChange(value, checked) {
            var _this2 = this;

            var options = [].concat(_toConsumableArray(this.state.options)); // 数组深拷贝
            var index = options.indexOf(value);

            if (checked) {
                if (index === -1) {
                    options.push(value);
                }
            } else {
                options.splice(index, 1);
            }

            if (!this.props.value) {
                this.setState({
                    options: options
                }, function () {
                    _this2.props.onChange && _this2.props.onChange(options);
                });
            } else {
                this.props.onChange && this.props.onChange(options);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var options = this.state.options;
            var _props = this.props,
                value = _props.value,
                children = _props.children,
                className = _props.className,
                style = _props.style;

            var classname = (0, _classnames2.default)(_defineProperty({
                'visui-checkbox-group': true
            }, className, className));

            var childrenElement = _react2.default.Children.map(children, function (element, index) {
                if (!element || !element.type) {
                    return null;
                }

                var elementType = element.type.elementType;

                if (elementType !== 'Checkbox' && elementType !== 'CheckboxText') {
                    return null;
                }

                return _react2.default.cloneElement(element, Object.assign({}, element.props, {
                    key: index,
                    className: 'visui-checkbox-group-item',
                    checked: element.props.checked || options.indexOf(element.props.value) >= 0,
                    onChange: _this3.onChange.bind(_this3, element.props.value)
                }));
            });

            return _react2.default.createElement(
                'div',
                { ref: 'CheckboxGroup', className: classname, style: style },
                childrenElement
            );
        }
    }]);

    return CheckboxGroup;
}(_react2.default.Component);

CheckboxGroup.defaultProps = {
    defaultValue: []
};
CheckboxGroup.childContextTypes = {
    component: _propTypes2.default.any
};
CheckboxGroup.propTypes = {
    defaultValue: _propTypes2.default.array,
    value: _propTypes2.default.array,
    disabled: _propTypes2.default.bool,
    onChange: _propTypes2.default.func
};

exports.default = CheckboxGroup;