'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var lastChoose = {
    type: null, // [choose|calcel]
    value: null
};

function cleanDate(dates) {
    var cache = {};
    dates.forEach(function (date) {
        var dateArr = [date.getFullYear(), date.getMonth() + 1, date.getDate()];
        cache[dateArr.join('-')] = dateArr;
    });

    return Object.keys(cache).map(function (key) {
        return new Date(cache[key]);
    });
}

function shiftKey(obj) {
    var _this = this;

    if (obj.event.shiftKey) {
        if (lastChoose.value) {
            (function () {
                var startTime = new Date(Math.min(obj.dealDate, lastChoose.value));
                var endTime = new Date(Math.max(obj.dealDate, lastChoose.value));
                while (startTime <= endTime) {
                    switch (lastChoose.type) {
                        case 'choose':
                            _this.datas.date.push(new Date(startTime));
                            break;
                        case 'cancel':
                            _this.datas.date = _this.datas.date.filter(function (date) {
                                return date < startTime || date > endTime;
                            });
                            break;
                    }
                    startTime.setDate(startTime.getDate() + 1);
                }
            })();
        }
        this.datas.date = cleanDate(this.datas.date);
        obj.event.preventDefault();
    }
    lastChoose.type = obj.type;
    lastChoose.value = obj.dealDate;
}

exports.default = shiftKey;