'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
var tools = {
    getOffset: function getOffset(dom) {
        var offset = {
            left: 0,
            top: 0
        };
        while (dom) {
            offset.left += dom.offsetLeft;
            offset.top += dom.offsetTop;
            dom = dom.offsetParent;
        }
        return offset;
    },
    getDate: function getDate(date) {
        var year = date.getFullYear();
        var month = '0' + date.getMonth();
        var day = '0' + date.getDate();
        return [year, month.slice(-2), day.slice(-2)];
    },
    getTime: function getTime(date) {
        var hour = void 0,
            min = void 0;
        if (date instanceof Date) {
            hour = '0' + date.getHours();
            min = '0' + date.getMinutes();
        } else {
            hour = '0' + date[0];
            min = '0' + date[1];
        }
        return [hour.slice(-2), min.slice(-2)];
    },
    dateEqual: function dateEqual(paramA, paramB) {
        return this.getDate(paramA).join('') - this.getDate(paramB).join('');
    },
    fixTimeByStep: function fixTimeByStep(time, step) {
        var timeBySecond = time;
        if (typeof time !== 'number') {
            var hour = parseInt(time[0]);
            var min = parseInt(time[1]);
            min = Math.min(59, min);
            if (hour >= 24) {
                hour = 24;
                min = 0;
            }
            timeBySecond = hour * 60 + min;
        }
        var timeAfterStep = Math.round(timeBySecond / step) * step;
        return [Math.floor(timeAfterStep / 60), timeAfterStep % 60];
    }
};

exports.default = tools;