'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _index = require('./_jDate/index.js');

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TimerPicker = function (_React$Component) {
    _inherits(TimerPicker, _React$Component);

    function TimerPicker(args) {
        _classCallCheck(this, TimerPicker);

        var _this = _possibleConstructorReturn(this, (TimerPicker.__proto__ || Object.getPrototypeOf(TimerPicker)).call(this, args));

        _this.state = {};
        return _this;
    }

    _createClass(TimerPicker, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _props = this.props,
                type = _props.type,
                defaultValue = _props.defaultValue,
                step = _props.step,
                onChange = _props.onChange;


            this._jdate = new _index2.default(this.input, {
                time: {
                    type: _index2.default[type],
                    value: defaultValue,
                    step: step
                },
                change: function change(value) {
                    delete value.date;
                    onChange && onChange(value);
                }
            });
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this._jdate.remove();
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            return _react2.default.createElement(
                'div',
                { className: 'visui-timepicker' },
                _react2.default.createElement('input', { className: 'visui-jDate',
                    ref: function ref(input) {
                        return _this2.input = input;
                    },
                    type: 'text',
                    placeholder: this.props.placeholder,
                    name: this.props.name,
                    disabled: this.props.disabled
                })
            );
        }
    }]);

    return TimerPicker;
}(_react2.default.Component);

TimerPicker.defaultProps = {
    type: 'Single',
    step: 1,
    placeholder: '请选择时间'
};
TimerPicker.propTypes = {
    type: _propTypes2.default.string,
    defaultValue: _propTypes2.default.array,
    step: _propTypes2.default.number,
    name: _propTypes2.default.string,
    disabled: _propTypes2.default.bool,
    onChange: _propTypes2.default.func
};
exports.default = TimerPicker;