'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _shallowequal = require('shallowequal');

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _index = require('../../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CheckboxGroup = _index.Checkbox.Group;

var Dropdown = function (_React$Component) {
    _inherits(Dropdown, _React$Component);

    function Dropdown(args) {
        _classCallCheck(this, Dropdown);

        var _this = _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, args));

        _this.state = {
            showDown: false,
            indeterminate: false,
            checkAll: false,
            checkedList: _this.props.value || []
        };
        _this.bodyClick = _this.bodyClick.bind(_this);
        _this.onChange = _this.onChange.bind(_this);
        _this.onCheckAllChange = _this.onCheckAllChange.bind(_this);
        _this.onCheckedListChange = _this.onCheckedListChange.bind(_this);
        return _this;
    }

    _createClass(Dropdown, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            // 外部通过value属性使组件受控
            if ('value' in nextProps && !(0, _shallowequal2.default)(nextProps.value, this.props.value)) {
                var checkedList = nextProps.value;
                this.setState({
                    checkedList: checkedList,
                    indeterminate: !!checkedList.length && checkedList.length < this.props.options.length,
                    checkAll: checkedList.length === this.props.options.length
                });
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            window.addEventListener('click', this.bodyClick);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            window.removeEventListener('click', this.bodyClick);
        }
    }, {
        key: 'bodyClick',
        value: function bodyClick(e) {
            var dom = e.target;
            var flag = true;
            var showDown = this.state.showDown;
            while (dom) {
                if (dom == this.refs.titleContainer) {
                    flag = false;
                    break;
                }
                dom = dom.parentNode;
            }
            if (flag && showDown) {
                this.setState({
                    showDown: false
                });
            }
        }
    }, {
        key: 'onChange',
        value: function onChange(checkedList) {
            this.setState({
                checkedList: checkedList,
                indeterminate: !!checkedList.length && checkedList.length < this.props.options.length,
                checkAll: checkedList.length === this.props.options.length
            }, this.onCheckedListChange);
        }
    }, {
        key: 'onCheckAllChange',
        value: function onCheckAllChange(checked) {
            this.setState({
                checkedList: checked ? this.props.options.map(function (item) {
                    return item.value;
                }) : [],
                indeterminate: false,
                checkAll: checked
            }, this.onCheckedListChange);
        }
    }, {
        key: 'onCheckedListChange',
        value: function onCheckedListChange() {
            this.props.onChange && this.props.onChange(this.state.checkedList);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _state = this.state,
                checkAll = _state.checkAll,
                indeterminate = _state.indeterminate,
                checkedList = _state.checkedList,
                showDown = _state.showDown;
            var _props = this.props,
                className = _props.className,
                style = _props.style,
                title = _props.title,
                options = _props.options;

            var classname = (0, _classnames2.default)(_defineProperty({
                'visui-dropdown': true
            }, className, className));
            return _react2.default.createElement(
                'div',
                { className: classname, style: style },
                _react2.default.createElement(
                    'div',
                    { ref: 'titleContainer',
                        className: 'visui-dropdown-title-container',
                        onClick: function onClick(e) {
                            _this2.setState({
                                showDown: !showDown
                            });
                        }
                    },
                    _react2.default.createElement(
                        'span',
                        { className: 'visui-dropdown-title-text' },
                        title,
                        checkedList.length > 0 ? _react2.default.createElement(
                            'span',
                            { className: 'visui-dropdown-num' },
                            '(',
                            checkedList.length,
                            ')'
                        ) : null
                    ),
                    _react2.default.createElement(_index.Icon, { type: 'arrow-down' })
                ),
                showDown && _react2.default.createElement(
                    'div',
                    { className: 'visui-dropdown-down-container', onClick: function onClick(e) {
                            e.nativeEvent.stopImmediatePropagation();
                        } },
                    _react2.default.createElement(
                        'div',
                        { key: -1, className: 'visui-dropdown-down-line' },
                        _react2.default.createElement(
                            _index.Checkbox,
                            { onChange: this.onCheckAllChange, indeterminate: indeterminate, checked: checkAll },
                            '\u5168\u9009'
                        )
                    ),
                    _react2.default.createElement(
                        CheckboxGroup,
                        { onChange: this.onChange, value: checkedList },
                        options && options.map(function (checkbox, index) {
                            return _react2.default.createElement(
                                _index.Checkbox,
                                { value: checkbox.value, key: index },
                                checkbox.label
                            );
                        })
                    )
                )
            );
        }
    }]);

    return Dropdown;
}(_react2.default.Component);

Dropdown.defaultProps = {
    title: '',
    options: []
};
Dropdown.propTypes = {
    title: _propTypes2.default.string.isRequired,
    options: _propTypes2.default.array,
    onChange: _propTypes2.default.func
};

exports.default = Dropdown;