'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

var _modal = require('../modal');

var _modal2 = _interopRequireDefault(_modal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Expand = function (_React$Component) {
    _inherits(Expand, _React$Component);

    function Expand(args) {
        _classCallCheck(this, Expand);

        var _this = _possibleConstructorReturn(this, (Expand.__proto__ || Object.getPrototypeOf(Expand)).call(this, args));

        _this.state = {
            showModal: false
        };
        return _this;
    }

    _createClass(Expand, [{
        key: 'componentDidMount',
        value: function componentDidMount() {}
    }, {
        key: 'getContent',
        value: function getContent() {
            var _this2 = this;

            var _props = this.props,
                className = _props.className,
                style = _props.style;

            var classname = (0, _classnames2.default)('visui-expand', className);

            return _react2.default.createElement(
                'div',
                { className: classname, style: style },
                this.props.children,
                !this.state.showModal && _react2.default.createElement(_icon2.default, { type: 'fullscreen', className: 'expand-open', onClick: function onClick() {
                        _this2.setState({ showModal: true });
                    } })
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var _this3 = this;

            var showModal = this.state.showModal;
            var _props2 = this.props,
                title = _props2.title,
                modalClassName = _props2.modalClassName,
                modalStyle = _props2.modalStyle;

            var modalClassname = (0, _classnames2.default)('visui-expand-modal', modalClassName);
            var content = this.getContent();

            return _react2.default.createElement(
                'div',
                { className: 'visui-expand-wrapper' },
                content,
                _react2.default.createElement(
                    _modal2.default,
                    {
                        className: modalClassname,
                        style: modalStyle,
                        title: title,
                        visible: showModal,
                        footer: null,
                        onCancel: function onCancel() {
                            _this3.setState({ showModal: false });
                        }
                    },
                    content
                )
            );
        }
    }]);

    return Expand;
}(_react2.default.Component);

Expand.defaultProps = {
    title: '展开内容'
};

Expand.propTypes = {
    title: _propTypes2.default.string,
    className: _propTypes2.default.string,
    style: _propTypes2.default.object,
    modalClassName: _propTypes2.default.string,
    modalStyle: _propTypes2.default.object
};

exports.default = Expand;