'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var List = function (_React$Component) {
    _inherits(List, _React$Component);

    function List(args) {
        _classCallCheck(this, List);

        var _this = _possibleConstructorReturn(this, (List.__proto__ || Object.getPrototypeOf(List)).call(this, args));

        _this.state = {
            hoverBlockId: null
        };
        _this.handleClick = _this.handleClick.bind(_this);
        return _this;
    }

    _createClass(List, [{
        key: 'componentDidMount',
        value: function componentDidMount() {}
    }, {
        key: 'handleClick',
        value: function handleClick() {
            this.props.onLoadMore && this.props.onLoadMore();
        }
    }, {
        key: 'clickItem',
        value: function clickItem(item) {
            this.props.onClick && this.props.onClick(item);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                className = _props.className,
                style = _props.style,
                data = _props.data,
                loadMore = _props.loadMore,
                loadSize = _props.loadSize,
                autoTitle = _props.autoTitle,
                formatValue = _props.formatValue,
                formatExtra = _props.formatExtra;

            var notitle = data.length && !('title' in data[0]) && !autoTitle && 'extra' in data[0];
            var noextra = data.length && !('extra' in data[0]) && ('title' in data[0] || autoTitle);
            var neither = data.length && !('title' in data[0]) && !autoTitle && !('extra' in data[0]);

            var classname = (0, _classnames2.default)(_defineProperty({
                'visui-list': true
            }, className, className));
            var titleclassname = (0, _classnames2.default)({
                'title': true,
                'noextra': noextra
            });
            var nameclassname = (0, _classnames2.default)({
                'name': true,
                'notitle': notitle,
                'noextra': noextra,
                'neither': neither
            });
            var valueclassname = (0, _classnames2.default)({
                'value': true,
                'noextra': noextra,
                'neither': neither
            });
            var extraclassname = (0, _classnames2.default)({
                'extra': true
            });
            var loadmoreclassname = (0, _classnames2.default)({
                'loadmore': true,
                'hidden': data.length !== parseInt(loadSize)
            });

            var listStr = data.map(function (item, index) {
                return _react2.default.createElement(
                    'p',
                    { key: 'listItem_' + index, className: 'visui-list-item', onClick: _this2.clickItem.bind(_this2, item) },
                    item.title || autoTitle && _react2.default.createElement(
                        'span',
                        { title: index + 1, className: titleclassname },
                        item.title || index + 1
                    ),
                    _react2.default.createElement(
                        'span',
                        { title: item.name, className: nameclassname },
                        item.name
                    ),
                    _react2.default.createElement(
                        'span',
                        { title: item.value, className: valueclassname },
                        formatValue ? formatValue(item.value) : item.value
                    ),
                    item.extra && _react2.default.createElement(
                        'span',
                        { title: item.extra, className: extraclassname },
                        formatExtra ? formatExtra(item.extra) : item.extra
                    )
                );
            });

            return _react2.default.createElement(
                'div',
                { className: classname, style: style },
                listStr,
                loadMore && _react2.default.createElement(
                    'p',
                    { onClick: this.handleClick, className: loadmoreclassname },
                    _react2.default.createElement(
                        'span',
                        null,
                        '\u52A0\u8F7D\u66F4\u591A'
                    ),
                    _react2.default.createElement(_icon2.default, { type: 'arrow-down' })
                )
            );
        }
    }]);

    return List;
}(_react2.default.Component);

List.defaultProps = {
    data: [],
    loadMore: false,
    loadSize: 10,
    autoTitle: true
};

List.propTypes = {
    data: _propTypes2.default.array.isRequired,
    loadMore: _propTypes2.default.bool,
    loadSize: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    autoTitle: _propTypes2.default.bool,
    formatValue: _propTypes2.default.func,
    formatExtra: _propTypes2.default.func,
    onClick: _propTypes2.default.func,
    onLoadMore: _propTypes2.default.func
};

exports.default = List;