'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

var _enzyme = require('enzyme');

var _sinon = require('sinon');

var _sinon2 = _interopRequireDefault(_sinon);

var _enzymeAdapterReact = require('enzyme-adapter-react-16');

var _enzymeAdapterReact2 = _interopRequireDefault(_enzymeAdapterReact);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _enzyme.configure)({ adapter: new _enzymeAdapterReact2.default() }); /**
                                                                          * @file 单元测试 Modal
                                                                          */


describe('enzyme test Modal', function () {
    var wrapper = (0, _enzyme.shallow)(_react2.default.createElement(
        _index2.default,
        { visible: false, title: 'hedongran' },
        'content'
    ));

    it('modal should be hidden', function () {
        expect(wrapper.hasClass('hidden')).toBeTruthy();
    });

    it('title should be hedongran', function () {
        expect(wrapper.find('.modal-header-text').text()).toEqual('hedongran');
    });

    it('renders children when passed in', function () {
        expect(wrapper.contains('content')).toBeTruthy();
    });

    it('when subimt button clicked, onSubmit() should be called', function () {
        var onSubmit = _sinon2.default.spy();
        wrapper = (0, _enzyme.shallow)(_react2.default.createElement(
            _index2.default,
            { visible: false, title: 'hedongran', onSubmit: onSubmit },
            'content'
        ));
        wrapper.find('Button').last().simulate('click');
        expect(onSubmit).toHaveProperty('callCount', 1);
    });

    it('when cancel button clicked, onCancel() should be called', function () {
        var onCancel = _sinon2.default.spy();
        wrapper = (0, _enzyme.shallow)(_react2.default.createElement(
            _index2.default,
            { visible: false, title: 'hedongran', onCancel: onCancel },
            'content'
        ));
        wrapper.find('Button').first().simulate('click');
        expect(onCancel).toHaveProperty('callCount', 1);
    });

    it('become mini when mini props is added', function () {
        wrapper = (0, _enzyme.shallow)(_react2.default.createElement(
            _index2.default,
            { visible: false, title: 'hedongran', mini: true },
            'content'
        ));
        expect(wrapper.hasClass('mini')).toBeTruthy();
    });
});