'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _index = require('../../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /**
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @file Modal组件
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * @author hedongran
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */


var Modal = function (_React$Component) {
    _inherits(Modal, _React$Component);

    function Modal(props) {
        _classCallCheck(this, Modal);

        var _this = _possibleConstructorReturn(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).call(this, props));

        _this.state = {};
        _this.onCancel = _this.onCancel.bind(_this);
        _this.onSubmit = _this.onSubmit.bind(_this);
        _this.onClickMask = _this.onClickMask.bind(_this);
        _this.bindKeyEvent = _this.bindKeyEvent.bind(_this);
        return _this;
    }

    _createClass(Modal, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            window.addEventListener('keydown', this.bindKeyEvent);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            window.removeEventListener('keydown', this.bindKeyEvent);
        }
    }, {
        key: 'bindKeyEvent',
        value: function bindKeyEvent(e) {
            if (this.props.visible && e.keyCode == 27) {
                this.onCancel();
            }
        }

        /**
         * 点击取消的回调函数
         */

    }, {
        key: 'onCancel',
        value: function onCancel() {
            this.props.onCancel && this.props.onCancel();
        }

        /**
         * 点击确定的回调函数
         */

    }, {
        key: 'onSubmit',
        value: function onSubmit() {
            this.props.onSubmit && this.props.onSubmit();
        }

        /**
         * 点击蒙层的触发事件
         */

    }, {
        key: 'onClickMask',
        value: function onClickMask(event) {
            var e = event.nativeEvent;
            var target = e.target;
            e.preventDefault();
            e.stopPropagation();
            if (this.props.maskClosable && target === this.mask) {
                this.onCancel();
            }
            return false;
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var _props = this.props,
                className = _props.className,
                style = _props.style,
                mini = _props.mini,
                title = _props.title,
                visible = _props.visible,
                hideCancel = _props.hideCancel,
                children = _props.children,
                footer = _props.footer;

            var showCancel = !hideCancel && !mini;
            var classname = (0, _classnames2.default)(_defineProperty({
                'visui-modal': true,
                'mini': mini,
                'hidden': !visible
            }, className, className));
            return _react2.default.createElement(
                'div',
                { className: classname, style: style, onClick: this.onClickMask, ref: function ref(mask) {
                        return _this2.mask = mask;
                    } },
                _react2.default.createElement(
                    'div',
                    { className: 'modal-container' },
                    _react2.default.createElement(
                        'div',
                        { className: 'modal-header' },
                        _react2.default.createElement(
                            'span',
                            { className: 'modal-header-text' },
                            title
                        ),
                        _react2.default.createElement(_index.Icon, { type: 'draw-circle', className: 'modal-close', onClick: this.onCancel })
                    ),
                    _react2.default.createElement(
                        'div',
                        { className: 'modal-content' },
                        children
                    ),
                    footer !== null && _react2.default.createElement(
                        'div',
                        { className: 'modal-footer' },
                        footer ? footer : _react2.default.createElement(
                            'div',
                            null,
                            showCancel && _react2.default.createElement(
                                _index.Button,
                                { type: 'default', onClick: this.onCancel },
                                '\u53D6\u6D88'
                            ),
                            _react2.default.createElement(
                                _index.Button,
                                { type: 'primary', size: mini ? 'large' : '', onClick: this.onSubmit },
                                '\u786E\u5B9A'
                            )
                        )
                    )
                )
            );
        }
    }]);

    return Modal;
}(_react2.default.Component);

Modal.defaultProps = {
    title: '',
    mini: false,
    visible: false,
    hideCancel: false,
    maskClosable: true,
    keyClosable: true
};

Modal.propTypes = {
    title: _propTypes2.default.string,
    mini: _propTypes2.default.bool,
    visible: _propTypes2.default.bool,
    footer: _propTypes2.default.any,
    hideCancel: _propTypes2.default.bool,
    maskClosable: _propTypes2.default.bool,
    keyClosable: _propTypes2.default.bool,
    onCancel: _propTypes2.default.func,
    onSubmit: _propTypes2.default.func
};

exports.default = Modal;