'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RadioGroup = function (_React$Component) {
    _inherits(RadioGroup, _React$Component);

    function RadioGroup(props) {
        _classCallCheck(this, RadioGroup);

        var _this = _possibleConstructorReturn(this, (RadioGroup.__proto__ || Object.getPrototypeOf(RadioGroup)).call(this, props));

        _this.state = {
            value: _this.props.value || props.defaultValue || null
        };
        return _this;
    }

    _createClass(RadioGroup, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.value !== this.props.value) {
                this.setState({
                    value: nextProps.value || nextProps.defaultValue
                });
            }
        }
    }, {
        key: 'getChildContext',
        value: function getChildContext() {
            return {
                component: this
            };
        }
    }, {
        key: 'onChange',
        value: function onChange(value) {
            if (!this.props.value) {
                this.setState({
                    value: value
                });
            }

            if (this.props.onChange && value !== this.state.value) {
                this.props.onChange(value);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this2 = this;

            var value = this.state.value;
            var _props = this.props,
                name = _props.name,
                children = _props.children,
                className = _props.className,
                style = _props.style;

            var classname = (0, _classnames2.default)(_defineProperty({
                'visui-radio-group': true
            }, className, className));
            return _react2.default.createElement(
                'div',
                { ref: 'RadioGroup', className: classname, style: style },
                _react2.default.Children.map(children, function (element) {
                    if (!element || !element.type) {
                        return null;
                    }

                    var elementType = element.type.elementType;

                    if (elementType !== 'Radio' && elementType !== 'RadioButton' && elementType !== 'RadioText') {
                        return null;
                    }

                    return _react2.default.cloneElement(element, Object.assign({}, element.props, {
                        onChange: _this2.onChange.bind(_this2),
                        className: 'visui-radio-group-item',
                        name: name,
                        model: value
                    }));
                })
            );
        }
    }]);

    return RadioGroup;
}(_react2.default.Component);

RadioGroup.defaultProps = {};
RadioGroup.childContextTypes = {
    component: _propTypes2.default.any
};
RadioGroup.propTypes = {
    name: _propTypes2.default.string,
    defaultValue: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.string, _propTypes2.default.number]),
    value: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.string, _propTypes2.default.number]),
    disabled: _propTypes2.default.bool,
    size: _propTypes2.default.string, // 只对 RadioButton 有效
    onChange: _propTypes2.default.func
};

exports.default = RadioGroup;