'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Radio = function (_React$Component) {
    _inherits(Radio, _React$Component);

    function Radio(props) {
        _classCallCheck(this, Radio);

        var _this = _possibleConstructorReturn(this, (Radio.__proto__ || Object.getPrototypeOf(Radio)).call(this, props));

        _this.state = {
            checked: _this.getChecked(props)
        };
        return _this;
    }

    _createClass(Radio, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(props) {
            var checked = this.getChecked(props);

            if (this.state.checked !== checked) {
                this.setState({ checked: checked });
            }
        }
    }, {
        key: 'parent',
        value: function parent() {
            return this.context.component;
        }
    }, {
        key: 'isDisabled',
        value: function isDisabled() {
            if (!this.parent()) {
                return this.props.disabled;
            }
            return this.props.disabled || this.parent().props.disabled;
        }
    }, {
        key: 'onChange',
        value: function onChange(e) {
            var checked = e.target.checked;

            if (checked) {
                if (this.props.onChange) {
                    this.props.onChange(this.props.value);
                }
            }

            if (!this.parent()) {
                this.setState({
                    checked: checked
                });
            }
        }
    }, {
        key: 'getChecked',
        value: function getChecked(props) {
            // model 适配 RadioGroup 的情况
            return props.model === props.value || Boolean(props.checked);
        }
    }, {
        key: 'render',
        value: function render() {
            var checked = this.state.checked;
            var _props = this.props,
                name = _props.name,
                value = _props.value,
                className = _props.className,
                style = _props.style,
                children = _props.children,
                onMouseEnter = _props.onMouseEnter,
                onMouseLeave = _props.onMouseLeave;

            var disabled = this.isDisabled();
            var classname = (0, _classnames2.default)({
                'visui-radio': true,
                'visui-radio-checked': checked,
                'visui-radio-disabled': disabled
            });
            var wrapperClassname = (0, _classnames2.default)(_defineProperty({
                'visui-radio-wrapper': true,
                'visui-radio-wrapper-disabled': disabled
            }, className, className));
            return _react2.default.createElement(
                'label',
                {
                    className: wrapperClassname,
                    style: style,
                    onMouseEnter: onMouseEnter,
                    onMouseLeave: onMouseLeave
                },
                _react2.default.createElement(
                    'span',
                    { className: classname },
                    _react2.default.createElement('input', {
                        type: 'radio',
                        className: 'visui-radio-original',
                        name: name,
                        value: value,
                        checked: checked,
                        disabled: disabled,
                        onChange: this.onChange.bind(this)
                    }),
                    _react2.default.createElement('span', { className: 'visui-radio-inner' })
                ),
                _react2.default.createElement(
                    'span',
                    { className: 'visui-radio-label' },
                    children || value
                )
            );
        }
    }]);

    return Radio;
}(_react2.default.Component);

Radio.elementType = 'Radio';
Radio.contextTypes = {
    component: _propTypes2.default.any
};
Radio.defaultProps = {
    value: '',
    checked: false,
    disabled: false
};
Radio.propTypes = {
    value: _propTypes2.default.oneOfType([_propTypes2.default.bool, _propTypes2.default.string, _propTypes2.default.number]).isRequired,
    disabled: _propTypes2.default.bool,
    checked: _propTypes2.default.bool,
    onChange: _propTypes2.default.func,
    onMouseEnter: _propTypes2.default.func,
    onMouseLeave: _propTypes2.default.func
};

exports.default = Radio;